
## Data loading, handling, and preprocessing
import os
import sys
import csv
import random
import numpy as np
import pandas as pd
from os import listdir
from os.path import isfile, join
from sklearn.preprocessing import StandardScaler

### Exploratory data analysis-Dimensionality reduction
from umap.umap_ import UMAP
from sklearn.decomposition import PCA

# Clustering
from sklearn.cluster import KMeans
#import hdbscan

# Modelling
import julia
from julia import Jchemo

from pinard import utils
from pinard import preprocessing as pp
from pinard.model_selection import train_test_split_idx

from sklearn.model_selection import train_test_split, cross_val_score, cross_val_predict, cross_validate
from sklearn.preprocessing import MinMaxScaler
from sklearn.pipeline import Pipeline, FeatureUnion
from sklearn.compose import TransformedTargetRegressor
from sklearn.metrics import mean_absolute_error, mean_squared_error, mean_absolute_percentage_error, r2_score
from sklearn.cross_decomposition import PLSRegression

## Images and plots 
from PIL import Image
import plotly.express as px
import matplotlib.pyplot as plt
import seaborn as sns
### Important Metrics
from sklearn.metrics import pairwise_distances_argmin_min

## Web app construction
import streamlit as st

# help on streamlit input https://docs.streamlit.io/library/api-reference/widgets

#Library for connecting to SQL DB
import pyodbc
#Library for reading the config file, which is in JSON
import json

# save models
import joblib
import pickle as pkl


from hyperopt import fmin, hp, tpe, Trials, space_eval, STATUS_OK, anneal
st.set_option('deprecation.showPyplotGlobalUse', False)
